//===----------------------------------------------------------------------===//
//
// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
// See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
//===----------------------------------------------------------------------===//
//
// WARNING: This test was generated by generate_feature_test_macro_components.py
// and should not be edited manually.
//
// clang-format off

// <complex>

// Test the feature test macros defined by <complex>

/*  Constant                       Value
    __cpp_lib_complex_udls         201309L [C++14]
    __cpp_lib_constexpr_complex    201711L [C++20]
*/

#include <complex>
#include "test_macros.h"

#if TEST_STD_VER < 14

# ifdef __cpp_lib_complex_udls
#   error "__cpp_lib_complex_udls should not be defined before c++14"
# endif

# ifdef __cpp_lib_constexpr_complex
#   error "__cpp_lib_constexpr_complex should not be defined before c++20"
# endif

#elif TEST_STD_VER == 14

# ifndef __cpp_lib_complex_udls
#   error "__cpp_lib_complex_udls should be defined in c++14"
# endif
# if __cpp_lib_complex_udls != 201309L
#   error "__cpp_lib_complex_udls should have the value 201309L in c++14"
# endif

# ifdef __cpp_lib_constexpr_complex
#   error "__cpp_lib_constexpr_complex should not be defined before c++20"
# endif

#elif TEST_STD_VER == 17

# ifndef __cpp_lib_complex_udls
#   error "__cpp_lib_complex_udls should be defined in c++17"
# endif
# if __cpp_lib_complex_udls != 201309L
#   error "__cpp_lib_complex_udls should have the value 201309L in c++17"
# endif

# ifdef __cpp_lib_constexpr_complex
#   error "__cpp_lib_constexpr_complex should not be defined before c++20"
# endif

#elif TEST_STD_VER == 20

# ifndef __cpp_lib_complex_udls
#   error "__cpp_lib_complex_udls should be defined in c++20"
# endif
# if __cpp_lib_complex_udls != 201309L
#   error "__cpp_lib_complex_udls should have the value 201309L in c++20"
# endif

# ifndef __cpp_lib_constexpr_complex
#   error "__cpp_lib_constexpr_complex should be defined in c++20"
# endif
# if __cpp_lib_constexpr_complex != 201711L
#   error "__cpp_lib_constexpr_complex should have the value 201711L in c++20"
# endif

#elif TEST_STD_VER == 23

# ifndef __cpp_lib_complex_udls
#   error "__cpp_lib_complex_udls should be defined in c++23"
# endif
# if __cpp_lib_complex_udls != 201309L
#   error "__cpp_lib_complex_udls should have the value 201309L in c++23"
# endif

# ifndef __cpp_lib_constexpr_complex
#   error "__cpp_lib_constexpr_complex should be defined in c++23"
# endif
# if __cpp_lib_constexpr_complex != 201711L
#   error "__cpp_lib_constexpr_complex should have the value 201711L in c++23"
# endif

#elif TEST_STD_VER > 23

# ifndef __cpp_lib_complex_udls
#   error "__cpp_lib_complex_udls should be defined in c++26"
# endif
# if __cpp_lib_complex_udls != 201309L
#   error "__cpp_lib_complex_udls should have the value 201309L in c++26"
# endif

# ifndef __cpp_lib_constexpr_complex
#   error "__cpp_lib_constexpr_complex should be defined in c++26"
# endif
# if __cpp_lib_constexpr_complex != 201711L
#   error "__cpp_lib_constexpr_complex should have the value 201711L in c++26"
# endif

#endif // TEST_STD_VER > 23

